﻿/* ========================================================
Beispielcode für den Versand von SMS über einen POST-Request
mit Visual C# 2008
Aufruf von Kommandozeile
Autor: Joachim Nenning info@alphaQuest.de
für www.sms4.de
===========================================================*/

using System;
using System.Net;
using System.Text;
using System.Web; //die Assembly unter "Verweise" hinzufügen
using System.IO;
using CommandLine.Utility;

namespace SMS4
{
    class Program
    {
        static void printHelp()
        {
            Console.WriteLine("-a,--a           Absenderkennung");
            Console.WriteLine("-d,--d           Debugmodus");
            Console.WriteLine("-h,--h           Diese Hilfe anzeigen.");
            Console.WriteLine("-hnr,--hnr       Handynummer (Pflicht)");
            Console.WriteLine("-kdnr,--kdnr     Kundennummer (Pflicht)");
            Console.WriteLine("-pw,--pw         Passwort (Pflicht)");
            Console.WriteLine("-t,--t           Tarif 1-5");
            Console.WriteLine("-txt,--txt       Text der SMS (Pflicht).");
            Console.WriteLine("-u,--u           User (Pflicht)");
            Console.WriteLine("\n");
        }
        
        static void Main(string[] args)
        {
            //Kommandozeilen-Argumente parsen
            Arguments CommandLine = new Arguments(args);          
            
            if (CommandLine["h"] != null)
            {
                printHelp();
            }
            else
            {
                if (CommandLine["d"] != null)
                {
                    Console.WriteLine("User         : " + CommandLine["u"]);
                    Console.WriteLine("Passwort     : " + CommandLine["pw"]);
                    Console.WriteLine("Kundennummer : " + CommandLine["kdnr"]);
                    Console.WriteLine("Handynummer  : " + CommandLine["hnr"]);
                    Console.WriteLine("Text         : " + CommandLine["txt"]);
                    Console.WriteLine("Tarif        : " + CommandLine["t"]);
                    Console.WriteLine("Absender     : " + CommandLine["a"]);
                    Console.WriteLine("\n");
                }

                if (CommandLine["u"] != null && CommandLine["pw"] != null && CommandLine["kdnr"] != null && CommandLine["hnr"] != null && CommandLine["txt"] != null)
                {
                    string kdnr = CommandLine["kdnr"];
                    string pw = CommandLine["pw"];
                    string user = CommandLine["u"];

                    string absender = "";
                    if (CommandLine["a"] != null)
                    {
                        absender = CommandLine["a"];
                    }

                    string handynr = CommandLine["hnr"];

                    string tarif = "3";
                    if (CommandLine["t"] != null)
                    {
                        tarif = CommandLine["t"];
                    }

                    string text = CommandLine["txt"]; // Text der SMS

                    Encoding encode = System.Text.Encoding.GetEncoding("iso-8859-1");

                    // URL zusammenbauen
                    string postData = "";

                    postData = "handynr=" + HttpUtility.UrlEncode(handynr, encode);
                    postData = postData + "&user=" + HttpUtility.UrlEncode(user, encode);
                    postData = postData + "&pwd=" + HttpUtility.UrlEncode(pw, encode);
                    postData = postData + "&kdnr=" + HttpUtility.UrlEncode(kdnr, encode);
                    postData = postData + "&text=" + HttpUtility.UrlEncode(text, encode);
                    postData = postData + "&tarif=" + HttpUtility.UrlEncode(tarif, encode);
                    postData = postData + "&absender=" + HttpUtility.UrlEncode(absender, encode);


                    // Stream zum Schreiben der Daten an das CGI-Skript
                    Stream output = null;

                    // Stream zum Einlesen der Daten von der URL
                    StreamReader input = null;

                    // Aufrufen der URL via POST
                    string uri = "http://www.sms4.de/cgi-bin/sms_out.pl";
                    HttpWebRequest request = (HttpWebRequest)WebRequest.Create(uri);

                    ASCIIEncoding encoding = new ASCIIEncoding();
                    byte[] byte1 = encoding.GetBytes(postData);

                    request.Method = "POST";
                    request.ContentType = "application/x-www-form-urlencoded";
                    request.ContentLength = byte1.Length;

                    try
                    {
                        // Daten an das CGI-Skript schicken
                        output = request.GetRequestStream();
                        output.Write(byte1, 0, byte1.Length);

                        // Verarbeitung des Ergebnisses
                        HttpWebResponse response = (HttpWebResponse)request.GetResponse();

                        // ResponseStream in StreamReader umwandeln 
                        input = new StreamReader(response.GetResponseStream(), encode);

                        //Meldung ausgeben
                        Console.WriteLine(input.ReadToEnd());
                        response.Close();
                        input.Close();

                    }
                    catch (WebException ex)
                    {
                        //HTTP error
                        Console.WriteLine(ex.Message);
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e.Message);
                    }
                    finally
                    {
                        if (output != null)
                        {
                            output.Close();
                        }
                    }
                }
                else
                {
                    Console.WriteLine("Missing 1 or more required options\n");
                    printHelp();
                }
            }
        }
    }
}
